> ## Documentation Index
> Fetch the complete documentation index at: https://docs.waffo.ai/llms.txt
> Use this file to discover all available pages before exploring further.

# サブスクリプション商品の更新

> 自動イミュータブルバージョニングでサブスクリプション商品のコンテンツを更新する

サブスクリプション商品のコンテンツを更新します。コンテンツが変更された場合、新しいイミュータブルバージョンが自動的に作成されます。コンテンツが現在のバージョンと同一の場合、新しいバージョンは作成されません。

```
POST /v1/actions/subscription-product/update-product
```

**認証：** API Key

## リクエストボディ

| フィールド           | 型              | 必須  | 説明                                                                   |
| --------------- | -------------- | --- | -------------------------------------------------------------------- |
| `id`            | string         | Yes | 商品 ID（`PROD_xxx` フォーマット）                                             |
| `name`          | string         | No  | 更新後の商品名（64 文字以下）                                                     |
| `billingPeriod` | string         | No  | `weekly`、`monthly`、`quarterly`、または `yearly`                          |
| `prices`        | object         | No  | 更新後のマルチ通貨価格                                                          |
| `description`   | string \| null | No  | 更新後の説明（`null` または `""` で消去可能）                                        |
| `media`         | array          | No  | 更新後のメディア                                                             |
| `successUrl`    | string \| null | No  | 更新後のリダイレクト URL（512 文字以下、有効な http(s) URL であること；`null` または `""` で消去可能） |
| `metadata`      | object         | No  | 更新後のメタデータ（`trialDays` を含む場合あり）                                       |

## リクエスト例

<CodeGroup>
  ```typescript SDK theme={"system"}
  const { product } = await client.subscriptionProducts.update({
    id: "PROD_3F7H2J5L8N1Q4S6U",
    name: "Pro Plan v2",
    billingPeriod: BillingPeriod.Monthly,
    prices: {
      USD: { amount: "39.00", taxIncluded: false, taxCategory: TaxCategory.SaaS },
      EUR: { amount: "36.00", taxIncluded: false, taxCategory: TaxCategory.SaaS },
    },
    metadata: { trialDays: 7 },
  });
  ```

  ```typescript TypeScript (fetch) theme={"system"}
  // Uses callApi() helper from authentication.mdx
  const result = await callApi("POST", "/v1/actions/subscription-product/update-product", {
    id: "PROD_3F7H2J5L8N1Q4S6U",
    name: "Pro Plan v2",
    billingPeriod: "monthly",
    prices: {
      USD: { amount: "39.00", taxIncluded: false, taxCategory: "saas" },
      EUR: { amount: "36.00", taxIncluded: false, taxCategory: "saas" },
    },
    metadata: { trialDays: 7 },
  });
  console.log(result.data);
  ```

  ```java Java theme={"system"}
  // Uses callApi() helper from authentication.mdx
  String body = """
      {"id":"PROD_3F7H2J5L8N1Q4S6U","name":"Pro Plan v2","billingPeriod":"monthly","prices":{"USD":{"amount":"39.00","taxIncluded":false,"taxCategory":"saas"},"EUR":{"amount":"36.00","taxIncluded":false,"taxCategory":"saas"}},"metadata":{"trialDays":7}}""";

  String response = callApi("POST", "/v1/actions/subscription-product/update-product", body);
  System.out.println(response);
  ```

  ```python Python theme={"system"}
  # Uses call_api() helper from authentication.mdx
  result = call_api("POST", "/v1/actions/subscription-product/update-product", {
      "id": "PROD_3F7H2J5L8N1Q4S6U",
      "name": "Pro Plan v2",
      "billingPeriod": "monthly",
      "prices": {
          "USD": {"amount": "39.00", "taxIncluded": False, "taxCategory": "saas"},
          "EUR": {"amount": "36.00", "taxIncluded": False, "taxCategory": "saas"},
      },
      "metadata": {"trialDays": 7},
  })
  print(result["data"])
  ```

  ```go Go theme={"system"}
  // Uses callAPI() helper from authentication.mdx
  body := map[string]interface{}{
      "id":            "PROD_3F7H2J5L8N1Q4S6U",
      "name":          "Pro Plan v2",
      "billingPeriod": "monthly",
      "prices": map[string]interface{}{
          "USD": map[string]interface{}{"amount": "39.00", "taxIncluded": false, "taxCategory": "saas"},
          "EUR": map[string]interface{}{"amount": "36.00", "taxIncluded": false, "taxCategory": "saas"},
      },
      "metadata": map[string]interface{}{"trialDays": 7},
  }
  result, err := callAPI("POST", "/v1/actions/subscription-product/update-product", body)
  if err != nil {
      log.Fatal(err)
  }
  fmt.Println(string(result))
  ```

  ```rust Rust theme={"system"}
  // Uses call_api() helper from authentication.mdx
  let body = serde_json::json!({
      "id": "PROD_3F7H2J5L8N1Q4S6U",
      "name": "Pro Plan v2",
      "billingPeriod": "monthly",
      "prices": {
          "USD": {"amount": "39.00", "taxIncluded": false, "taxCategory": "saas"},
          "EUR": {"amount": "36.00", "taxIncluded": false, "taxCategory": "saas"}
      },
      "metadata": {"trialDays": 7}
  });
  let result = call_api("POST", "/v1/actions/subscription-product/update-product", &body).await?;
  println!("{}", result);
  ```

  ```c C theme={"system"}
  /* Uses call_api() helper from authentication.mdx */
  const char *body = "{\"id\":\"PROD_3F7H2J5L8N1Q4S6U\",\"name\":\"Pro Plan v2\",\"billingPeriod\":\"monthly\",\"prices\":{\"USD\":{\"amount\":\"39.00\",\"taxIncluded\":false,\"taxCategory\":\"saas\"},\"EUR\":{\"amount\":\"36.00\",\"taxIncluded\":false,\"taxCategory\":\"saas\"}},\"metadata\":{\"trialDays\":7}}";
  char *response = call_api("POST", "/v1/actions/subscription-product/update-product", body);
  printf("%s\n", response);
  free(response);
  ```

  ```cpp C++ theme={"system"}
  // Uses callApi() helper from authentication.mdx
  std::string body = R"({"id":"PROD_3F7H2J5L8N1Q4S6U","name":"Pro Plan v2","billingPeriod":"monthly","prices":{"USD":{"amount":"39.00","taxIncluded":false,"taxCategory":"saas"},"EUR":{"amount":"36.00","taxIncluded":false,"taxCategory":"saas"}},"metadata":{"trialDays":7}})";
  std::string response = callApi("POST", "/v1/actions/subscription-product/update-product", body);
  std::cout << response << std::endl;
  ```

  ```bash cURL theme={"system"}
  MERCHANT_ID="MER_2aUyqjCzEIiEcYMKj7TZtw"
  TIMESTAMP=$(date +%s)
  BODY='{
    "id": "PROD_3F7H2J5L8N1Q4S6U",
    "name": "Pro Plan v2",
    "billingPeriod": "monthly",
    "prices": {
      "USD": { "amount": "39.00", "taxIncluded": false, "taxCategory": "saas" },
      "EUR": { "amount": "36.00", "taxIncluded": false, "taxCategory": "saas" }
    },
    "metadata": { "trialDays": 7 }
  }'
  BODY_HASH=$(echo -n "$BODY" | openssl dgst -sha256 -binary | base64 -w 0)
  CANONICAL_REQUEST="POST
  /v1/actions/subscription-product/update-product
  $TIMESTAMP
  $BODY_HASH"

  SIGNATURE=$(echo -n "$CANONICAL_REQUEST" | openssl dgst -sha256 -sign private_key.pem | base64 -w 0)

  curl -X POST "https://api.waffo.ai/v1/actions/subscription-product/update-product" \
    -H "Content-Type: application/json" \
    -H "X-Merchant-Id: $MERCHANT_ID" \
    -H "X-Timestamp: $TIMESTAMP" \
    -H "X-Signature: $SIGNATURE" \
    -d "$BODY"
  ```

  ```bash wget theme={"system"}
  MERCHANT_ID="MER_2aUyqjCzEIiEcYMKj7TZtw"
  TIMESTAMP=$(date +%s)
  BODY='{
    "id": "PROD_3F7H2J5L8N1Q4S6U",
    "name": "Pro Plan v2",
    "billingPeriod": "monthly",
    "prices": {
      "USD": { "amount": "39.00", "taxIncluded": false, "taxCategory": "saas" },
      "EUR": { "amount": "36.00", "taxIncluded": false, "taxCategory": "saas" }
    },
    "metadata": { "trialDays": 7 }
  }'
  BODY_HASH=$(echo -n "$BODY" | openssl dgst -sha256 -binary | base64 -w 0)
  CANONICAL_REQUEST="POST
  /v1/actions/subscription-product/update-product
  $TIMESTAMP
  $BODY_HASH"

  SIGNATURE=$(echo -n "$CANONICAL_REQUEST" | openssl dgst -sha256 -sign private_key.pem | base64 -w 0)

  wget -qO- "https://api.waffo.ai/v1/actions/subscription-product/update-product" \
    --header="Content-Type: application/json" \
    --header="X-Merchant-Id: $MERCHANT_ID" \
    --header="X-Timestamp: $TIMESTAMP" \
    --header="X-Signature: $SIGNATURE" \
    --post-data="$BODY"
  ```
</CodeGroup>

## 成功レスポンス (200)

```json theme={"system"}
{
  "data": {
    "product": {
      "id": "PROD_3F7H2J5L8N1Q4S6U",
      "storeId": "STO_2D5F8G3H1K4M6N9P",
      "name": "Pro Plan v2",
      "description": null,
      "billingPeriod": "monthly",
      "prices": {
        "USD": { "amount": "39.00", "taxCategory": "saas" },
        "EUR": { "amount": "36.00", "taxCategory": "saas" }
      },
      "media": [],
      "successUrl": null,
      "metadata": { "trialDays": 7 },
      "status": "active",
      "createdAt": "2026-03-30T10:30:00.000Z",
      "updatedAt": "2026-03-30T11:00:00.000Z"
    }
  }
}
```

## レスポンスフィールド

[サブスクリプション商品の作成レスポンス](/api-reference/endpoints/subscription-products/create-product#response-fields)と同じです。

<Warning>
  商品の更新は**新しいイミュータブルバージョン**を作成します。既存のサブスクリプションは元のバージョンを保持します。新規登録は最新バージョンを使用します。送信されたコンテンツが現在のバージョンと同一の場合、新しいバージョンは作成されません。
</Warning>

## エラー

> **リトライポリシー**：4xx は一切リトライしない — リクエストを修正してから再送信。5xx は指数バックオフでリトライ（5s 開始、最大 3 回）。

| ステータス | `errors[0].message`                                                                   | 意味                                                                        | 推奨処理                                    |
| ----- | ------------------------------------------------------------------------------------- | ------------------------------------------------------------------------- | --------------------------------------- |
| 400   | `Missing header: x-context-merchant-id`                                               | マーチャントコンテキスト header が転送されていない                                             | SDK 設定を修正                               |
| 400   | `Missing or invalid header: x-context-environment`                                    | 環境 header が欠落、または `test` / `prod` ではない                                    | `X-Environment` を `test` または `prod` に設定 |
| 400   | `Missing required field: id`                                                          | リクエストボディに `id` が含まれない                                                     | `id` を追加して再送信                           |
| 400   | `Expected format: PROD_xxx, got "X"`                                                  | `id` が正しい Short ID ではない                                                   | `PROD_` 接頭辞付きの Short ID を使用             |
| 400   | `Field name must be a non-empty string`                                               | 空文字列の `name` を渡した                                                         | `name` を省略すれば元の値を保持、または非空文字列を渡す         |
| 400   | `Invalid billingPeriod`                                                               | `billingPeriod` が `weekly` / `monthly` / `quarterly` / `yearly` の集合に含まれない | 4 つの許可値のいずれかに変更                         |
| 400   | `Field prices must be a non-empty object`                                             | 空の `prices` を渡した                                                          | `prices` を省略すれば元の値を保持、または少なくとも 1 通貨を含める |
| 400   | `Invalid currency code: "X". Must be 3 uppercase letters (e.g., "USD", "EUR", "JPY")` | `prices` のキーが ISO 4217 コードに準拠していない                                        | 3 文字の大文字を使用                             |
| 400   | `Invalid amount for X: "Y". Must be a positive number string (e.g., "9.99", "1000")`  | 金額文字列がパースできない                                                             | 正の十進数文字列を使用                             |
| 400   | メッセージに `has no version` を含む                                                           | 対象環境（`test` または `prod`）にバージョンがまだない                                        | 先にこの環境でバージョンを作成（test から公開、または test で作成） |
| 401   | `Unauthorized`                                                                        | 認証失敗                                                                      | API Key、タイムスタンプ、署名を確認                   |
| 404   | `Product not found` / `Current version not found`                                     | product ID が存在しない（または現行バージョン欠落）                                           | product ID を確認                          |
| 500   | `Internal server error`                                                               | 一時的な下流障害                                                                  | 指数バックオフでリトライ（5s 開始、最大 3 回）              |
